Urduhack: NLP library for ( 🇵🇰 ) Urdu language
================================================

[![License: MIT](https://img.shields.io/badge/license-MIT-blue.svg)](https://github.com/urduhack/urduhack/blob/master/LICENSE)
[![image](https://img.shields.io/pypi/v/urduhack.svg)](https://pypi.org/project/urduhack/)
[![image](https://img.shields.io/pypi/pyversions/urduhack.svg)](https://pypi.org/project/urduhack/)
[![wheel](https://img.shields.io/pypi/wheel/urduhack.svg)](https://pypi.org/project/urduhack/)
[![Build Status](https://travis-ci.org/urduhack/urduhack.svg?branch=master)](https://travis-ci.org/urduhack/urduhack)
[![codecov](https://codecov.io/gh/urduhack/urduhack/branch/master/graph/badge.svg)](https://codecov.io/gh/urduhack/urduhack)
![Last commit](https://img.shields.io/github/last-commit/urduhack/urduhack.svg)
[![image](https://img.shields.io/github/contributors/urduhack/urduhack.svg)](https://github.com/urduhack/urduhack/graphs/contributors)
[![Downloads](https://pepy.tech/badge/urduhack)](https://pepy.tech/project/urduhack)
[![Join Slack](https://img.shields.io/badge/join-us%20on%20slack-gray.svg?longCache=true&logo=slack&colorB=red)](https://join.slack.com/t/urduhack/shared_invite/enQtNDE5NDg4NzU2Mzg4LTk3ZDNlYzBhOWM5MGY0ZGE0ZmNmNzU2ZTViYjAwMTg3NTBmZGU4OTM0M2E0MzQ0NDI1MDIyYzVkYTVmZTkyZjg)
[![Say Thanks!](https://img.shields.io/badge/Say%20Thanks-!-1EAEDB.svg)](https://saythanks.io/to/akkefa)


Feature Support
---------------

- [x] Normalization
    - [x] Arabic and Urdu Unicode Redundancy Problem
    - [x] Character Normalization
    - [x] Combined Characters Normalization 
    - [x] Diacritics Removal
    - [x] Spaces Before & After Digits
    - [x] Spaces After Punctuations
    - [x] Joined Words Fix
- [ ] Tokenization
    - [x] Sentence Tokenization
    - [ ] Words Tokenization

Roadmap
---------
- [ ] Classification
  - [ ] Sentimental Analysis
  - [ ] Sentence Classification
  - [ ] Documents Classification
- [ ] Name Entity Recognition
- [ ] Image to Text
- [ ] Speak to Text


Installation
------------

Urduhack officially supports Python 3.6–3.7, and runs great on PyPy.

To install Requests, simply use pip
``` {.sourceCode .bash}
$ pip install urduhack
```

Documentation
-------------

Fantastic documentation is available at <https://urduhack.readthedocs.io/>

How to Contribute
-----------------

1.  Check for open issues or open a fresh issue to start a discussion
    around a feature idea or a bug. There is a [Contributor Friendly](https://github.com/urduhack/urduhack/issues)
    tag for issues that should be ideal for people who are not very
    familiar with the codebase yet.
3.  Write a test which shows that the bug was fixed or that the feature
    works as expected.
4.  Send a pull request and bug the maintainer until it gets merged and
    published. :)

Community
----------

Get updates on UrduHack nlp development and chat with the project maintainers and community members.

Contributors
-------------

Special thanks to everyone who contributed to getting the UrduHack to the current state.

Sponsors
----------

Support this project by becoming a sponsor. Your logo will show up here with a link to your website. [[Become a sponsor]()]

<a href="https://arbisoft.com" target="_blank"><img height="64" src="https://arbisoft.com/static/media/uploads/arbisoft.png"></a>

Copyright and license
---------------------

Code released under the [MIT License](ttps://github.com/urduhack/urduhack/blob/master/LICENSE).